SystemOrganization addCategory: #ConfigurationOfPharogenesis!

Object subclass: #ConfigurationOfPharogenesis
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPharogenesis'!

!ConfigurationOfPharogenesis class methodsFor: 'development support' stamp: 'MaxLeske 3/21/2011 19:34'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPharogenesis class methodsFor: 'private' stamp: 'MaxLeske 3/21/2011 19:34'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPharogenesis class methodsFor: 'private' stamp: 'MaxLeske 3/21/2011 19:34'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPharogenesis class methodsFor: 'private' stamp: 'MaxLeske 3/21/2011 19:34'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPharogenesis class methodsFor: 'metacello tool support' stamp: 'MaxLeske 3/21/2011 19:34'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPharogenesis class methodsFor: 'loading' stamp: 'MaxLeske 3/21/2011 19:34'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPharogenesis class methodsFor: 'loading' stamp: 'MaxLeske 3/21/2011 19:34'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPharogenesis class methodsFor: 'loading' stamp: 'MaxLeske 3/21/2011 19:34'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPharogenesis class methodsFor: 'accessing' stamp: 'MaxLeske 3/21/2011 19:34'!
project

	^self new project! !

!ConfigurationOfPharogenesis class methodsFor: 'development support' stamp: 'MaxLeske 3/21/2011 19:34'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPharogenesis methodsFor: 'baselines' stamp: 'MaxLeske 3/21/2011 19:36'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.squeaksource.com/GitFS'.
		spec project: #FSGit with: [
				spec
					className: 'ConfigurationOfFSGit';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/GitFS' ].
		spec package: 'PharoGenesis' with: [
				spec requires: #('FSGit' ). ].
		spec group: 'default' with: #('PharoGenesis' ). ].
! !

!ConfigurationOfPharogenesis methodsFor: 'symbolic versions' stamp: 'MaxLeske 3/21/2011 19:35'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfPharogenesis methodsFor: 'accessing' stamp: 'MaxLeske 3/21/2011 19:34'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPharogenesis methodsFor: 'versions' stamp: 'MaxLeske 3/21/2011 19:35'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'MaxLeske'.
		spec timestamp: '3/21/2011 19:35'.
		spec project: #FSGit with: '1.0'.
		spec package: 'Pharogenesis' with: 'Pharogenesis'. ].
! !
